// nvsts is a multi-directional shooter game.
// Copyright (C) 2008 Carles Creus Lopez
//
// nvsts is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>
// or write to the Free Software Foundation, Inc., 51 Franklin Street,
// Fifth Floor, Boston, MA 02110-1301 USA.
//
// You may contact the author at <crazycraft@gmail.com>

#ifndef DEBRIS_HPP
#define DEBRIS_HPP

#include "Automaton.hpp"

namespace au {

// a game-useless class, but looks nice
class Debris : public Automaton{
	public:
		// ctor
		Debris( const util::Vector& xy, const util::Vector& v, real red, real green, real blue, real alpha = 1.0 );
		// dtor
		virtual ~Debris();

		// unserializes the automaton
		static void unserialize( std::istream& in );

		// color getters
		real get_red();
		real get_green();
		real get_blue();
		real get_alpha();

	private:
		// color
		real red;
		real green;
		real blue;
		real alpha;

	// redefined automaton functions

	public:
		// serializes the automaton
		virtual void serialize( std::ostream& out );

	protected:
		// drawing function
		virtual void specific_draw();
		// process function
		virtual void specific_process( int milliseconds );
		// collision functions
		virtual void send_collision( int& res, Automaton *a );
};

}

#endif // Debris.hpp
