// nvsts is a multi-directional shooter game.
// Copyright (C) 2008 Carles Creus Lopez
//
// nvsts is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>
// or write to the Free Software Foundation, Inc., 51 Franklin Street,
// Fifth Floor, Boston, MA 02110-1301 USA.
//
// You may contact the author at <crazycraft@gmail.com>

#ifndef SPAWNED_HPP
#define SPAWNED_HPP

#include "Automaton.hpp"

namespace au {

// the spawned enemy
class Spawned : public Automaton{
 	public:
		// ctor
		Spawned( Spawn *swarmer, const util::Vector& xy, real phase, bool play = true );
		// dtor
		virtual ~Spawned();

		// gets current phase
		real get_phase() const;
		// sets the phase
		void set_phase( real newphase );

	private:
		// phase angle in the circle
		real phase;

		// central brain
		Spawn *swarmer;

	// redefined automaton functions

	public:
		// scoring points
		virtual int get_killscore() const;

	protected:
		// collision functions
		virtual void send_collision( int& res, Automaton *a );
};

}

#endif // Spawned.hpp
