// nvsts is a multi-directional shooter game.
// Copyright (C) 2008 Carles Creus Lopez
//
// nvsts is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>
// or write to the Free Software Foundation, Inc., 51 Franklin Street,
// Fifth Floor, Boston, MA 02110-1301 USA.
//
// You may contact the author at <crazycraft@gmail.com>

#ifndef MENU_ROOT_HPP
#define MENU_ROOT_HPP

#include "Menu_Component.hpp"

namespace gui {

class Menu_Root : public Menu_Component{
	public:
		// ctor
		Menu_Root();
		// dtor
		virtual ~Menu_Root();

		// root pane start
		virtual void start( int from );
		// functions to process user events
		virtual void exit();
		virtual void move( int updown );
		virtual void change( int moreless );
		virtual void accept();

		// capture ended
		virtual void notify( bool success, SDLKey key, int joy, int axis_but, bool invert );

	private:
		// root pane ended
		void end();
		// updates the text
		void update();
};

}

#endif // Menu_Root.hpp
