// nvsts is a multi-directional shooter game.
// Copyright (C) 2008 Carles Creus Lopez
//
// nvsts is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>
// or write to the Free Software Foundation, Inc., 51 Franklin Street,
// Fifth Floor, Boston, MA 02110-1301 USA.
//
// You may contact the author at <crazycraft@gmail.com>

#ifndef CONSTANTS_HPP
#define CONSTANTS_HPP

#include <string>
#include "../util/Real.hpp"

namespace rc {

// sets up a new definition
extern void add_define( const std::string& d );
// initializes the rc [depends on: -]
extern void init();
// initialize all recorded drawings
extern void initalldrawings();
// ends the rc
extern void finalize();

// constant's getters
#define BOOL_VAR( x ) extern bool x();
#define INT_VAR( x )  extern int x();
#define REAL_VAR( x ) extern real x();
#include "Macro.hpp"
#undef BOOL_VAR
#undef INT_VAR
#undef REAL_VAR

}

#endif // Constants.hpp
