// nvsts is a multi-directional shooter game.
// Copyright (C) 2008 Carles Creus Lopez
//
// nvsts is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>
// or write to the Free Software Foundation, Inc., 51 Franklin Street,
// Fifth Floor, Boston, MA 02110-1301 USA.
//
// You may contact the author at <crazycraft@gmail.com>

#include <ctime>
#include "Random.hpp"

// PRNG
boost::lagged_fibonacci607 util::Random::gen;

// (re)initializes the random number generation [depends on: -]
void util::Random::init(){
	gen.seed( std::time(NULL) );
}
// get a [-1,1] random number
real util::Random::get(){
	return (uget()-0.5)*2;
}
// get a [0,1] random number
real util::Random::uget(){
	return gen();
}
// get a [-x,x] random number
real util::Random::get( real x ){
	return x * get();
}
// get a [min,max] random number
real util::Random::get( real min, real max ){
	return min + (max-min)*uget();
}
